//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//
#ifndef INST_PROGRAM_HXX
# define INST_PROGRAM_HXX

# include "inst/program.hh"

namespace inst
{

  //
  inline TextSection &
  Program::text_section()
  {
    return text_section_;
  }
  inline const TextSection &
  Program::text_section() const
  {
    return text_section_;
  }

  inline DataSection &
  Program::data_section()
  {
    return data_section_;
  }
  inline const DataSection &
  Program::data_section() const
  {
    return data_section_;
  }

  //
  inline void
  Program::write(std::ostream &ostr) const
  {
    ostr << data_section_;
    ostr << text_section_;
  }

  inline std::ostream &
  operator<< (std::ostream &ostr, const Program &p)
  {
    p.write(ostr);
    return ostr;
  }

} // namespace inst

#endif // !INST_PROGRAM_HXX
