//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2004, 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//

//
// WARNING: Generated file, do not edit by hand!
//

/** \file inst/sb.hh
    \brief Declare the interface of Sb */
#ifndef INST_SB_HH
# define INST_SB_HH
# include "inst/register.hh"
# include "inst/exp.hh"
# include "inst/inst.hh"

namespace inst
{

  /// Declare Sb.
  /** Store the low byte from src at address 
(offset + base).  */
  class Sb:
    public Inst
  {
    /** \name Ctor & dtor.
        \{ */
  public:
    /// Construct a(n) Sb node.
    Sb(const Register &src, const CountedExp &offset, const Register &base);
    /// Destroy a(n) Sb node.
    virtual ~Sb();
    /** \} */

    /** \name Accessors.
        \{ */
  public:
    /// Return src
    const Register &		get_src() const ;
    /// Return src
    Register &		get_src() ;
    /// Return offset
    const Exp &		get_offset() const ;
    /// Return offset
    Exp &		get_offset() ;
    /// Return base
    const Register &		get_base() const ;
    /// Return base
    Register &		get_base() ;
    /** \} */

    /** \name Visitors entry point.
        \{ */
  public:
    /// Accept a const visitor \a v.
    virtual void accept(ConstVisitor& v) const;
    /// Accept a non-const visitor \a v.
    virtual void accept(Visitor& v);
    /** \} */

  public:
    /// Print this
    virtual void	write(std::ostream &ostr) const;

  protected:
    Register	src_;
    CountedExp	offset_;
    Register	base_;
  };

} // namespace inst

# include "inst/sb.hxx"

#endif // !INST_SB_HH
