//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2003, 2004 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//

#include <iostream>

#include "common.hh"
#include "misc/contract.hh"
#include "parse/libparse.hh"
#include "parse-tasks.hh"

// Parse module related tasks' implementation.
namespace parse
{

  namespace tasks
  {

    void
    trace_scan ()
    {
      trace_scan_p = true;
    }

    void
    unlimited_regs ()
    {
      unlimited_regs_p = true;
    }

    void
    trace_parse ()
    {
      trace_parse_p = true;
    }

    void
    nop_after_branch ()
    {
      nop_after_branch_p = true;
    }

    inst::Program*      program = 0;
    void
    parse ()
    {
      if (filename == NULL)
        {
          std::cerr << "You must specify an input file.\n";
          exit (exit_failure);
        }

      program = ::parse::parse(filename);
      if (!program)
        {
          std::cerr << "Parsing Failed\n";
          if (!exit_status)
            exit_status = exit_parse;
          exit (exit_status);
        }
    }

  } // namespace tasks

} // namespace parse
