//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//
#ifndef SHELL_CMD_HXX
# define SHELL_CMD_HXX

# include "shell/cmd.hh"

namespace shell
{

  //
  inline
  Cmd::Cmd(const identifier_type id):
    id_(id)
  {
  }

  inline
  Cmd::~Cmd()
  {
  }

  //
  inline void
  Cmd::push_arg(const std::string &arg)
  {
    list_args_.push_back(arg);
  }

  inline const Cmd::list_args_type &
  Cmd::get_args() const
  {
    return list_args_;
  }

  inline Cmd::identifier_type
  Cmd::get_identifier() const
  {
    return id_;
  }

} // namespace shell

#endif // !SHELL_CMD_HXX
